<template>
    <div class="list-view">
        <div class="filters-container">
            <!-- <el-input placeholder="输入关键字" v-model="search" clearable class="filter-item"></el-input>
            <el-button @click="getData" type="primary" icon="el-icon-search" class="filter-item">搜索 </el-button> -->
            <!-- <el-button @click="addRow" type="primary" icon="el-icon-plus" class="filter-item">创建申请 </el-button> -->
            <!-- <el-button
                @click="download"
                type="primary"
                icon="el-icon-download"
                :loading="downloading"
                class="filter-item"
                >导出EXCEL
            </el-button> -->
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <!-- <el-table-column prop="id" label="ID" width="100"> </el-table-column> -->
            <el-table-column prop="organizer" label="一级指标"> </el-table-column>
            <el-table-column prop="createdAt" label="二级指标"></el-table-column>
            <el-table-column prop="year" label="评定项目和要求"> </el-table-column>
            <el-table-column prop="status" label="分值" :formatter="statusFormatter"> </el-table-column>
            <el-table-column label="评定分" align="right" fixed="right" min-width="150">
                <template slot-scope="{ row }">
                    <el-button
                        v-if="row.status === 'FIRST_REVIEW_PENDING'"
                        :loading="row.loading"
                        @click="audit(row, 'REVIEW_PENDING', '通过')"
                        type="success"
                        size="mini"
                        plain
                    >
                        通过
                    </el-button>
                    <el-button
                        v-if="row.status === 'FIRST_REVIEW_PENDING'"
                        :loading="row.loading"
                        @click="dismiss(row)"
                        type="warning"
                        size="mini"
                        plain
                    >
                        驳回
                    </el-button>
                    <el-button @click="sorce(row)" type="primary" size="mini" plain v-if="row.status === 'EXPERT_PASS'"
                        >查看分数</el-button
                    >
                    <el-button
                        @click="supervision(row.id)"
                        type="success"
                        size="mini"
                        plain
                        v-if="(row.status === 'ASSIGN_EXPERT') & display"
                        >分配专家组</el-button
                    >
                    <!-- <el-button
                        @click="supervision(row.id)"
                        type="success"
                        size="mini"
                        plain
                        v-if="(row.status === 'SUBMIT_GRADE' || row.status === 'REVIEW_PENDING') & display"
                        >查看专家组</el-button
                    > -->
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>查看附件</el-button>
                    <!-- <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button> -->
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <!-- <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination> -->
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';

export default {
    name: 'RateList',
    mixins: [pageableTable],
    data() {
        return {
            multipleMode: false,
            search: '',
            downloading: false,
            statusOptions: [
                { label: '等待初审', value: 'FIRST_REVIEW_PENDING' },
                { label: '待分配专家组', value: 'ASSIGN_EXPERT' },
                { label: '待复审', value: 'REVIEW_PENDING' },
                { label: '初审驳回', value: 'FIRST_REVIEW_DENY' },
                { label: '待提交成绩', value: 'SUBMIT_GRADE' },
                { label: '专家拒绝', value: 'EXPERT_DENY' }
            ],
            supervisor: [],
            dialogVisible: false,
            rateId: '',
            display: false
        };
    },
    created() {
        this.getAdmin();
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        },
        ...mapState(['userInfo'])
    },
    mounted() {},
    methods: {
        statusFormatter(row, column, cellValue, index) {
            let selectedOption = this.statusOptions.find(i => i.value === cellValue);
            if (selectedOption) {
                return selectedOption.label;
            }
            return '';
        },
        beforeGetData() {},
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/rateEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                // path: '/rateAudit',
                path: '/organization',
                query: {
                    // organId: row.organizationId,
                    // rateId: row.id
                    id: row.id,
                    status: row.status
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/rate/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/rate/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        },
        audit(row, status, remark) {
            this.$set(row, 'loading', true);
            this.$http
                .post('/rate/audit', {
                    id: row.id,
                    status: status,
                    score: 0,
                    remark: remark
                })
                .then(res => {
                    this.$set(row, 'loading', false);
                    this.$message.success('OK');
                    this.getData();
                })
                .catch(e => {
                    console.log(e);
                    this.$set(row, 'loading', false);
                    this.$message.error(e.error);
                });
        },
        dismiss(row) {
            this.$prompt('请输入驳回缘由', '提示', {
                confirmButtonText: '确定',
                cancelButtonText: '取消'
            })
                .then(({ value }) => {
                    this.audit(row, 'FIRST_REVIEW_DENY', value);
                })
                .catch(() => {
                    this.$message({
                        type: 'info',
                        message: '取消输入'
                    });
                });
        },
        supervision(id) {
            this.$router.push({
                path: '/assignExpert',
                query: {
                    id: id
                }
            });
            // this.dialogVisible = true;
            // this.rateId = id;
        },
        addRegulatory(id) {
            this.$http
                .post('/rate/addExpert', {
                    id: this.rateId,
                    userId: id
                })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.dialogVisible = false;
                    this.recordId = '';
                    this.getData();
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        sorce(row) {
            this.$alert('专家打出的分数为:' + row.score, '分数', {
                confirmButtonText: '确定'
            });
        },
        getAdmin() {
            let data = this.userInfo.authorities;
            data.forEach(element => {
                if (element.name === 'ROLE_ADMIN') {
                    this.display = true;
                }
            });
        }
    }
};
</script>
<style lang="less" scoped></style>
